library(stockassessment)
load("run/model.RData")
FC<-list()
set.seed(12345)


library(stockassessment)
load("run/model.RData")
FC<-list()
#set.seed(12345)
#FC[[length(FC)+1]] <- forecast(fit, fscale=c(1,1,1,1), ave.years=max(fit$data$years) + ((-3):(-1)), lagR=TRUE, label="Fsq")


set.seed(12345)
FC[[length(FC)+1]] <- forecast(fit, fscale=c(1,NA,NA,NA), catchval=c(NA,4953,NA,NA), fval=c(NA,NA ,0.882,0.882), 
                                    ave.years=max(fit$data$years) + ((-3):(-1)), lagR=TRUE, label="Fsq", year.base=2020, rec.years = max(fit$data$years) + ((-10):(-1)), savesim=TRUE)
                                    
 
#set.seed(12345)
#FC[[length(FC)+1]] <- forecast(fit, fscale=c(1,NA,NA,NA), catchval=c(NA,4953,NA,NA), fval=c(NA, NA,0.537 ,0.537), 
#                                    ave.years=max(fit$data$years) + ((-3):(-1)), lagR=TRUE, label="Fsq base2020", year.base=2020, rec.years = max(fit$data$years) + ((-10):(-1)), savesim=TRUE)
                                     
   
set.seed(12345)
FC[[length(FC)+1]] <- forecast(fit, fscale=c(1,NA,NA,NA), catchval=c(NA,4953,NA,NA), fval=c(NA,NA, 0.26,0.26), 
                                    ave.years=max(fit$data$years) + ((-3):(-1)), lagR=TRUE, label="Fmsy", year.base=2020, rec.years = max(fit$data$years) + ((-10):(-1)), savesim=TRUE)

set.seed(12345)
FC[[length(FC)+1]] <- forecast(fit, fscale=c(1,NA,NA,NA), catchval=c(NA,4953,NA,NA), fval=c(NA,NA,0.17,0.17), 
                                    ave.years=max(fit$data$years) + ((-3):(-1)), lagR=TRUE, label="Lower", year.base=2020, rec.years = max(fit$data$years) + ((-10):(-1)), savesim=TRUE)

set.seed(12345)
FC[[length(FC)+1]] <- forecast(fit, fscale=c(1,NA,NA,NA), catchval=c(NA,4953,NA,NA), fval=c(NA,NA,0.44,0.44), 
                                    ave.years=max(fit$data$years) + ((-3):(-1)), lagR=TRUE, label="Upper", year.base=2020, rec.years = max(fit$data$years) + ((-10):(-1)), savesim=TRUE)
                                    
                                    set.seed(12345)
FC[[length(FC)+1]] <- forecast(fit, fscale=c(1,NA,NA,NA), catchval=c(NA,4953,NA,NA), fval=c(NA,NA, 0.087,0.087), 
                                    ave.years=max(fit$data$years) + ((-3):(-1)), lagR=TRUE, label="Fmsy Ratio", year.base=2020, rec.years = max(fit$data$years) + ((-10):(-1)), savesim=TRUE)

set.seed(12345)
FC[[length(FC)+1]] <- forecast(fit, fscale=c(1,NA,NA,NA), catchval=c(NA,4953,NA,NA), fval=c(NA,NA,0.057,0.057), 
                                    ave.years=max(fit$data$years) + ((-3):(-1)), lagR=TRUE, label="Lower Ratio", year.base=2020, rec.years = max(fit$data$years) + ((-10):(-1)), savesim=TRUE)

set.seed(12345)
FC[[length(FC)+1]] <- forecast(fit, fscale=c(1,NA,NA,NA), catchval=c(NA,4953,NA,NA), fval=c(NA,NA,0.148,0.148), 
                                    ave.years=max(fit$data$years) + ((-3):(-1)), lagR=TRUE, label="Upper Ratio", year.base=2020, rec.years = max(fit$data$years) + ((-10):(-1)), savesim=TRUE)

set.seed(12345)
FC[[length(FC)+1]] <- forecast(fit, fscale=c(1,NA,NA,NA), catchval=c(NA,4953,NA,NA), fval=c(NA,NA,0.689,0.26), 
                                    ave.years=max(fit$data$years) + ((-3):(-1)), lagR=TRUE, label="F=Fpa", year.base=2020, rec.years = max(fit$data$years) + ((-10):(-1)), savesim=TRUE)

set.seed(12345)
FC[[length(FC)+1]] <- forecast(fit, fscale=c(1,NA,NA,NA), catchval=c(NA,4953,NA,NA), fval=c(NA,NA, 1.23,0.26), 
                                    ave.years=max(fit$data$years) + ((-3):(-1)), lagR=TRUE, label="F=Flim", year.base=2020, rec.years = max(fit$data$years) + ((-10):(-1)), savesim=TRUE)

set.seed(12345)
FC[[length(FC)+1]] <- forecast(fit, fscale=c(1,NA,NA,NA), catchval=c(NA,4953,NA,NA), fval=c(NA,NA,0.000001,0.000001), 
                                    ave.years=max(fit$data$years) + ((-3):(-1)), lagR=TRUE, label="Fzero", year.base=2020, rec.years = max(fit$data$years) + ((-10):(-1)), savesim=TRUE)

                 
set.seed(12345)
FC[[length(FC)+1]] <- forecast(fit, fscale=c(1,NA,NA,NA), catchval=c(NA,4953,NA,NA), fval=c(NA,NA,0.0001,0.46), 
                                   ave.years=max(fit$data$years) + ((-3):(-1)), lagR=TRUE, label="SSB=Bpa", year.base=2020, rec.years = max(fit$data$years) + ((-10):(-1)), savesim=TRUE)
                                    
set.seed(12345)
FC[[length(FC)+1]] <- forecast(fit, fscale=c(1,NA,NA,NA), catchval=c(NA,4953,NA,NA), fval=c(NA,NA,0.133,0.46), 
                                    ave.years=max(fit$data$years) + ((-3):(-1)), lagR=TRUE, label="SSB=Blim", year.base=2020, rec.years = max(fit$data$years) + ((-10):(-1)), savesim=TRUE)
                                    
                                    
set.seed(12345)
FC[[length(FC)+1]] <- forecast(fit, fscale=c(1,NA,NA,1), catchval=c(NA, 4953,1315, NA), 
                                    ave.years=max(fit$data$years) + ((-3):(-1)), lagR=TRUE, label="F=F_R", year.base=2020, rec.years = max(fit$data$years) + ((-10):(-1)), savesim=TRUE)
                                    
set.seed(12345)
FC[[length(FC)+1]] <- forecast(fit, fscale=c(1,NA,NA,NA), catchval=c(NA,4953,NA,NA), fval=c(NA,NA, 0.26,0.26), 
                                    ave.years=max(fit$data$years) + ((-3):(-1)), lagR=TRUE, label="Fmsy", year.base=2020, rec.years = max(fit$data$years) + ((-10):(-1)), savesim=TRUE)



Blim=15067
above<-function(x){xx<-mean(x[[4]]$ssb>Blim);yr<-x[[4]]$year; round(xx*100,1)}
Pabove<-lapply(FC, above)
names(Pabove)<-lapply(FC, function(x){attr(x,"label")})
Pabove<-as.matrix(unlist(Pabove))
colnames(Pabove)<-paste0("P(SSB",FC[[1]][[4]]$year, " > ",Blim,") in %")


save(FC, Pabove, file="run/forecast.RData")



